/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * tools/signal_process.c: wrapper for signalling the IRCd process
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: signal_process.c,v 1.3 2002/11/03 21:50:08 rageircd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>

int main(int argc, char *argv[])
{
	pid_t process_id = 0;
	if (argc < 3 || *argv[1] == '\0' || *argv[2] == '\0') {
		return 0;
	}
	if ((process_id = atoi(argv[1])) == 0) {
		return 0;
	}
	if (!strcasecmp(argv[2], "hup")) {
		kill(process_id, SIGHUP);
		return 1;
	}
	if (!strcasecmp(argv[2], "term")) {
		kill(process_id, SIGTERM);
		return 1;
	}
	return 0;
}
